﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Abt.Controls.SciChart;

namespace AnnotationLabelPopup
{
    internal class PopupLabelModifier : ChartModifierBase
    {
        public override void OnModifierMouseMove(ModifierMouseArgs e)
        {
            base.OnModifierMouseMove(e);

            var relativeToModifierSurface = GetPointRelativeTo(e.MousePoint, ModifierSurface);
            
            var verticalAnnotations = ParentSurface.Annotations.OfType<VerticalLineAnnotation>();
            
            var mouseOverAnnotations = verticalAnnotations.Where(x => x.IsPointWithinBounds(relativeToModifierSurface));

            foreach (var annotation in verticalAnnotations)
            {
                if (mouseOverAnnotations.Any(x => x.Equals(annotation)))
                {
                    foreach (var annotationLabel in annotation.AnnotationLabels)
                    {
                        annotationLabel.Visibility = Visibility.Visible;
                    }
                }
                else
                {
                    foreach (var annotationLabel in annotation.AnnotationLabels)
                    {
                        annotationLabel.Visibility = Visibility.Hidden;
                    }
                }
            }
        }
    }
}
